searchNodes=[{"doc":"HXL An Elixir implementation of HCL Features Decode from string or file Aims to be fully compliant with the HCL specification Function &amp; variables support during evaluation Example Usage hcl = &quot;&quot;&quot; resource &quot;upcloud_server&quot; &quot;server1&quot; { hostname = &quot;terraform.example.com&quot; zone = &quot;nl-ams1&quot; plan = &quot;1xCPU-1GB&quot; template { size = 25 storage = &quot;01000000-0000-4000-8000-000030200200&quot; } network_interface { type = &quot;public&quot; } login { user = &quot;root&quot; keys = [ &quot;ssh-rsa public key&quot;, ] create_password = true password_delivery = &quot;email&quot; } connection { host = &quot;127.0.0.2&quot; type = &quot;ssh&quot; user = &quot;root&quot; private_key = file(&quot;~/.ssh/rsa_private_key&quot;) } provisioner &quot;remote-exec&quot; { inline = [ &quot;echo &#39;Hello world!&#39;&quot; ] } } &quot;&quot;&quot; { :ok , config_file } = HXL . decode ( hcl , functions : %{ &quot;file&quot; =&gt; &amp; File . read / 1 } ) From file { :ok , config_file } = HXL . decode_file ( &quot;/path/to/file&quot; ) As ast hcl = &quot;&quot;&quot; service &quot;http&quot; { a = 1 b = 2 } &quot;&quot;&quot; { :ok % HXL.Body { } } = HXL . decode_as_ast ( hcl ) Installation Add hxl to your list of dependencies in mix.exs : def deps do [ { :hxl , &quot;~&gt; 0.1.0&quot; } ] end HCL Syntax Specification Lexical Elements [x] Comments [x] Identifiers [x] Operators &amp; delimiters [x] Numeric literals Structural Language [x] Body [x] Attributes [x] Blocks [x] One-line blocks Expression language [x] Expressions [x] Expr term [x] Literal Value [x] Collection Value [x] Template Expr [x] Variable Expr [x] Function Call [x] For Expr [x] ExprTerm Index [x] ExprTerm GetAttr [x] ExprTerm Splat [x] &quot;(&quot; Expression &quot;)&quot; [x] Operation [x] Conditional Template Language [] TemplateLiteral [] TemplateInterpolation [] TemplateDirective Representations [x] HCL Native syntax [ ] JSON","ref":"HXL.html","title":"HXL","type":"module"},{"doc":"Decode a binary to a HCL document. decode/2 parses and evaluates the AST before returning the HCL docuement. If the document is using functions in it's definition, these needs to be passed in the opts part of this functions. See bellow for an example Options The following options can be passed to configure evaluation of the document: :evaluator - A HXL.Evaluator module to interpret the AST during evaluation. See HXL.Evaluator for more information. :functions - A map of (&lt;function_name&gt; -&gt; &lt;function&gt;) to make available in document evaluation. :variables - A map of Top level variables that should be injected into the context when evaluating the document. :keys - controls how keys in the parsed AST are evaluated. Possible values are: :strings (default) - evaluates keys as strings :atoms - converts keys to atoms with String.to_atom/1 :atoms! - converts keys to atoms with String.to_existing_atom/1 (key -&gt; term) - converts keys using the provided function Examples Using functions: iex&gt; hcl = &quot;a = upper(trim(&quot; a &quot;))&quot; &quot;a = upper(trim(&quot; a &quot;))&quot; iex&gt; HXL . decode ( hcl , functions : %{ &quot;upper&quot; =&gt; &amp; String . capitalize / 1 , &quot;trim&quot; =&gt; &amp; String . trim / 1 } ) { :ok , %{ &quot;a&quot; =&gt; &quot;A&quot; } } Using variables: iex&gt; hcl = &quot;a = b&quot; &quot;a = b&quot; iex&gt; HXL . decode ( hcl , variables : %{ &quot;b&quot; =&gt; &quot;B&quot; } ) { :ok , %{ &quot;a&quot; =&gt; &quot;B&quot; } }","ref":"HXL.html#decode/2","title":"HXL.decode/2","type":"function"},{"doc":"Reads a HCL document from a binary. Returns the document or raises HXL.Error . See from_binary/1","ref":"HXL.html#decode!/2","title":"HXL.decode!/2","type":"function"},{"doc":"Decode a binary to a HXL document AST. Examples iex&gt; HXL . decode_as_ast ( &quot;a = 1&quot; ) { :ok , % HXL.Ast.Body { statements : [ % HXL.Ast.Attr { expr : % HXL.Ast.Literal { value : { :int , 1 } } , name : &quot;a&quot; } ] } }","ref":"HXL.html#decode_as_ast/1","title":"HXL.decode_as_ast/1","type":"function"},{"doc":"Reads a HCL document from file. Uses same options as decode/2 Examples iex&gt; HXL . decode_file ( &quot;/path/to/file.hcl&quot; ) { :ok , %{ &quot;a&quot; =&gt; &quot;b&quot; } }","ref":"HXL.html#decode_file/2","title":"HXL.decode_file/2","type":"function"},{"doc":"Reads a HCL document from file, returns the document directly or raises HXL.Error . See decode_file/1","ref":"HXL.html#decode_file!/2","title":"HXL.decode_file!/2","type":"function"},{"doc":"","ref":"HXL.html#t:opt/0","title":"HXL.opt/0","type":"type"},{"doc":"","ref":"HXL.html#t:opts/0","title":"HXL.opts/0","type":"type"},{"doc":"HCL Ast","ref":"HXL.Ast.html","title":"HXL.Ast","type":"module"},{"doc":"","ref":"HXL.Ast.html#t:collection_value/0","title":"HXL.Ast.collection_value/0","type":"type"},{"doc":"","ref":"HXL.Ast.html#t:expr_term/0","title":"HXL.Ast.expr_term/0","type":"type"},{"doc":"","ref":"HXL.Ast.html#t:t/0","title":"HXL.Ast.t/0","type":"type"},{"doc":"Defines the behaviour for custom evaluation of the AST returned from HXL.Parser See eval/2 for more information","ref":"HXL.Evaluator.html","title":"HXL.Evaluator","type":"behaviour"},{"doc":"This functions is invoked for every AST node. There's a base implementation of a evaluator which is expected to be used by implmenters for handling nodes they're not interested in. Example An example would be to implement Terraform specific behaviours such as modules: hcl = &quot;&quot; \\ &quot; module &quot; servers &quot; { source = &quot; . / servers &quot; servers = 5 } &quot; &quot; \\ &quot; Using HXL.Evaluator.Base the result would be: %{ &quot;module&quot; =&gt; %{ &quot;servers&quot; =&gt; %{ &quot;servers&quot; =&gt; 5 , &quot;source&quot; =&gt; &quot;./servers&quot; } } } Using a different evaluator we can change how we interpret the AST: defmodule Terraform.Evaluator do use HXL.Evaluator alias HXL.Ast . { Block , Body , Attr } alias HXL.Evaluator.Base @impl true def eval ( % Block { type : &quot;module&quot; = t , labels : [ mod_name ] , body : body } , % HXL.Eval { } = ctx ) do mod = mod_from_body ( body ) # We&#39;re not interesed to put anything in the document but to populate the # ctx with the ability to lookup values from the module symbol_table = put_in ( ctx . symbol_table , [ Access . key ( t , %{ } ) , mod_name ] , mod ) { :ignore , %{ ctx | symbol_table : symbol_table } } end def eval ( ast , ctx ) , do : Base . eval ( ast , ctx ) defp mod_from_body ( % Body { statements : stmts } ) do case Enum . reduce ( stmts , { nil , [ ] } , &amp; mod_args / 2 ) do { nil , _ } -&gt; raise ArgumentError , message : &quot;`source` argument are required for Terramform modules&quot; { source , args } -&gt; HXL . decode_file! ( source &lt;&gt; &quot;.tf&quot; , evaluator : __MODULE__ , variables : mod_variables ( args ) ) end end defp mod_args ( % Attr { name : &quot;source&quot; , expr : expr } , { _ , args } ) do source = expr |&gt; HXL.Evaluator.Base . eval ( %{ } ) |&gt; elem ( 0 ) { source , args } end defp mod_args ( arg , { source , args } ) do { source , [ arg | args ] } end defp mod_variables ( args ) do for arg &lt;- args , into : %{ } do arg |&gt; HXL.Evaluator.Base . eval ( % HXL.Eval { } ) |&gt; elem ( 0 ) end end end Given the following HCL document: hcl = &quot;&quot; \\ &quot; module &quot; servers &quot; { source = &quot; . / servers &quot; servers = 5 } instance = module.servers.instances &quot; &quot; \\ &quot; And a module file servers.tf : instances = [ &quot;127.0.0.1&quot; , &quot;127.0.0.2&quot; , &quot;127.0.0.3&quot; , &quot;127.0.0.4&quot; , &quot;127.0.0.5&quot; ] Eval using the Terraform.Evaluator iex&gt; HXL . decode! ( hcl , evaluator : Terraform.Evaluator ) %{ &quot;instance&quot; =&gt; [ &quot;127.0.0.1&quot; , &quot;127.0.0.2&quot; , &quot;127.0.0.3&quot; , &quot;127.0.0.4&quot; , &quot;127.0.0.5&quot; ] }","ref":"HXL.Evaluator.html#c:eval/2","title":"HXL.Evaluator.eval/2","type":"callback"},{"doc":"","ref":"HXL.Evaluator.html#t:t/0","title":"HXL.Evaluator.t/0","type":"type"},{"doc":"","ref":"HXL.Evaluator.Base.html","title":"HXL.Evaluator.Base","type":"module"},{"doc":"","ref":"HXL.Evaluator.Base.html#eval_op/3","title":"HXL.Evaluator.Base.eval_op/3","type":"function"},{"doc":"","ref":"HXL.Evaluator.Base.html#scope/2","title":"HXL.Evaluator.Base.scope/2","type":"function"},{"doc":"This module implements Config.Provider behaviour, so that HCL files can be used for configuration of releases. The provided file will be read by HXL.Provider during boot, the resulting Ast is evaluated with the given options, with the exception of the keys , which will always be set to :atoms . See Config.Provider for more info. Usage config_providers : [ { HXL.Provider , [ { :system , &quot;RELEASE_ROOT&quot; , &quot;/path/to/config.hcl&quot; } ] } ] Using a keyword list with options config_providers : [ { HXL.Provider , path : &quot;/path/to/config.hcl&quot; , functions : %{ } , variables : %{ } } ]","ref":"HXL.Provider.html","title":"HXL.Provider","type":"module"},{"doc":"HXL.Error","ref":"HXL.Error.html","title":"HXL.Error","type":"exception"},{"doc":"Internal errors to printable messages","ref":"HXL.Error.html#format_reason/1","title":"HXL.Error.format_reason/1","type":"function"}]